.model tiny,c                     
include boot.inc
include bios.inc

.code

       jmp debut
       db 30h dup(0)       ; rservation d'space.

       intro db 'Chargement du noyau en cours ...',13,10
       errio db 'Echec d''Entre/Sortie sur ce disque,',13,10,
                'Appuyer sur une touche pour rebooter.',13,10


  debut:
      cli
      mov ax,07c0h        ; Initialisation des sgments  07C0h
      mov ds,ax
      mov es,ax
      mov ax,stackseg
      mov ss,ax           ; Initialisation de ss  04000h   ; une pile
      mov sp,stackoffset  ; Initiallisation de sp  0fff0h  ; temporaire
      push es
      mov ax,1000h        ; seg de donnes que le noyau compltera par le biais du module sdh16
      mov es,ax
      xor bx,bx
      mov byte ptr es:[bx],dl     ; DL contient l'ID du lecteur de boot
      pop es

      @cls                        ; efface l'cran
      @setcsrpos 0,0,0            ; Positionne le curseur au dbut de l'cran
      .386
      mov eax,20000100h           ; chargement du noyau  2000h:0100h
      invoke rwdsk,0,2,0,2,17,eax ; lecture de 17 secteurs du noyau

   ; 0=disquette,2=lecture,0=tete,2=secteur,17=nbrsect_chager,adresse=2000h:100h
   ; N.B: invoke accepte au max 6 paramtres.

      mov eax,20002500h
      invoke rwdsk,0,2,1,1,18, eax
      
      invoke print, addr intro,lengthof intro,01ah ; affiche le message d'intro

      mov ax,2000h
      mov ds,ax
      mov es,ax
      mov ss,ax
      mov sp,0fffeh

      ;jmp far 2000h:0100h l'instruction n'est pas supporte par masm
      db 0eah,00,01h,00,20h ;alors on crit le code correspondant

mov ax,0012h
int 20h
;===========================
;AFFICHE CHAINE DE CARACTERE
;===========================
  print proc near sg:dword,taille:word, couleur:word
   @GetMode
   .IF (al==3)
       mov bl,07h
   .ELSE
  mov bl, byte ptr couleur    ;dfinit la couleur (pour mode graphique uniquement)
  .ENDIF
  lds si,sg               
  mov cx,taille               ;taille de la chaine de caractre
  .repeat
    mov ah,0eh
    mov al, byte ptr [si]
    int 10h
    inc si
    dec cx
  .until (cx==0)
  ret
  print endp

;==================================
;LIRE/ECRIRE DES SECTEURS PHISIQUES
;==================================

rwdsk proc near USES es bx,lecteur:byte,fct:byte,tete:byte,
                          sect:byte, nbrsect:byte, buff:dword
   clc
   les bx,buff     ; Pointeur ES:BX sur buff
   mov ah,fct
   mov dl,lecteur
   mov al,nbrsect
   mov cl,sect
   mov ch,0
   mov dh,tete
   int 13h
   jnc ok_io

mov al,90h   ; En cas d'erreur: Bip sonore d'une dure d'1 seconde
out 63h,al   
mov al,3
out 61h,al
mov ah,086h
mov cx,0fh
mov dx,0f240h
int 15h
mov al,0
out 61h,al   ; Bip dsactiv

invoke print,addr errio,lengthof errio,7
jmp sortie

ok_io:
    ret
 rwdsk endp

sortie:
    xor ax,ax
    int 16h  ; attente d'une touche au clavier
    int 19h  ; reboot
jmp sortie


org 510
dw 0aa55h                 ; Nombre magique      

END
