/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/


#include <kernel.h>
#include <proc.h>

#define LPT 0x378

extern u8 kbdmap[];     //contient la map du clavier

char buffer_clavier[256];
char *bot_buffer_clavier;
char *top_buffer_clavier;

extern u8 id_aperiodique_clavier;

/*********************************************************************************/

thread_clavier()
{
  u8 i=0;     
  while((inpb(0x64) & 0x01) == 0);
  i=inpb(0x60);
  i--;

    if ((i<=85) && (top_buffer_clavier <= &buffer_clavier[256]))
         *(top_buffer_clavier++)=kbdmap[i*4];  //insertion du caractre lu depuis la map clavier, dans le buffer clavier
                 
    else if (i<=85){
       signaler_aperiodique(0);
              print_rt("Buffer clavier plein :%p\n",top_buffer_clavier);}

}

/**********************************************************************************/

thread_affichage()
{
  char c;
  //extraction d'un caractre du tampon clavier

  while(1)
  {
      if  (bot_buffer_clavier!=top_buffer_clavier)
           {
             goto label;
           }
      else  
           bot_buffer_clavier=top_buffer_clavier=&buffer_clavier[0];

    while(bot_buffer_clavier==top_buffer_clavier); //attente d'une insertion d'un caractre
    label:
      print_rt("%c",*bot_buffer_clavier++);
  }

}

/************************************************************************************************/

thread_signal()
 {
  u8 sig=0;
   while(1)
   {
    outpb(LPT,sig=~sig);
    suspendre_tache_delai(1000);    //mentient le niveau du signal jusqu'a l'epuisement de la capacite (1ms)
   }
 }

/********************************************************************************************************/

void application_tr()
 {
  int i;

   i=creer_tache((THREAD)&thread_clavier,0,1,0,0);  /*Ri,Ci,Pi,num_file_sem*/
     if (i<0) print_rt("Erreur -%d: Cration de l'apriodique clavier.\n",-i);
        else {
              id_aperiodique_clavier=i; //sera utilis dans la routine d'interruption pour signaler l'arrive de l'IT (voir call_int51 dans .\32\ints.cpp).
              print_rt("* Tche [%d]: Apriodique associe au clavier (Ci=%dut)\n",i,tache[i].sched.ci);
             }
   i=creer_tache((THREAD)&thread_affichage,0,1,4,0);
     if (i<0) print_rt("Erreur -%d: Cration de la priodique affichage.\n",-i);
        else print_rt("* Tche [%d]: Priodique pour l'affichage (Ci=%dut  Pi=%dut)\n",i,tache[i].sched.ci,tache[i].sched.pi);

   i=creer_tache((THREAD)&thread_signal,0,1,5,0); //pour un signal carr sur LPT, la priode est de 20ut<=> 19.53ms
     if (i<0) print_rt("Erreur -%d: Cration de la priodique pour le signal carr (LPT).\n",-i);
        else print_rt("* Tche [%d]: Priodique pour le signal carr (LPT). (Ci=%dut  Pi=%dut)\n",i,tache[i].sched.ci,tache[i].sched.pi);

   i=creer_serveur(0,1,4);
     if (i<0) print_rt("Erreur -%d: Cration du serveur des apriodiques.\n",-i);
            else print_rt("* Tche [%d]: Serveur d'apriodiques (Ci=%dut  Pi=%dut)\n",i,tache[i].sched.ci,tache[i].sched.pi);

   i=faisabilite();         // test de faisabilit RM (ordonnanabilit)
   if (i<0) print_rt("Faisabilit erreur: -%d\n",-i);
           else  print_rt("Faisabilit du systme... OK.\n");

   activer_horloge();   // activer l'horloge temps rel et lancement du systme de tches temps rel.
   while(1);
 }
