#include "couleur.h"

   typedef unsigned short int u16;
   typedef unsigned long u32;
   typedef unsigned char u8;
   typedef unsigned long TIME;
   typedef double DATE;
   typedef void * THREAD;
   typedef struct tache * TACHE;
   typedef struct semaphore * SEMAPHORE;

#ifdef __C32__         /*Far non support en 32-bit*/


               #ifdef __C16__
                #undef __C16__
               #endif

   #include <define.h>         //contient des macros 

   #define _fptr

   #define NULL (struct tache *)0


   #define adr_init_gdt 0x40000

   #define ADR_KR_PGD   0x1A000   // adresse du rpertoire des pages du noyau,
   #define ADR_KR_PGT1  0x1B000   // l'adresse de la 1ere table des pages,
   #define ADR_KR_PGT2  0x1C000   // l'adresse de la 2eme table des pages.

   #define ADR_TACHE_STACK_IT 0x7FFFFE  // adresse du debut de la zone de pile pour les tache, lors des IT
                                        // on reserve pour chaque processus 1Ko d'espace.

   #define ADR_TACHE_STACK_TR 0x5FFFFE  // adresse du dbut de la zone de pile pour les tches Temps Rel.
                                        // On reserve pour chaque tche 2K d'espace pile.
   #define NBR_IT_PERIO 1024

   #define KR_DS        0x10      // voir "..\init_gdt.asm" pour les valeurs suivantes
   #define KR_CS        8
   #define USER_CS      0x2B
   #define USER_DS      0x33

   #define adr_context_reel 0x90000
   #define adr_param_reel   0x90100
   #define reel_buffer      0x90200 /*9000:0200 adresse du buffer pour le basculeur*/

   #define printk(x,y) strcpy((char *)reel_buffer,(char *)x);\
                       id_printk((u16)y);\
                       sauver_context((u32) adr_context_reel,1)

   #define _print_rt(x) cli_tr();\
                        printk(x,couleur_base);\
                        sti_tr()


   #define putchr(x,y,z) id_putchr((u16) x,(u16) y,(u16) z);\
                         sauver_context((u32) adr_context_reel,1)


   #define __write(l,c,t,s,a) id_write((u8) l,(u16) c,(u16) t,(u16) s);\
                           strcpy((char *)reel_buffer,(char *)a);\
                           sauver_context((u32) adr_context_reel,1)
                           

   #define __read(l,c,t,s) id_read((u8) l,(u16) c,(u16) t,(u16) s);\
                           sauver_context((u32) adr_context_reel,1)



   //extern void _print_rt(const char *);
   extern void print_rt(char *,...);
   extern void affich_rt(char *,...);
   extern void _affich_rt(const char *);

   extern void id_printk(u16 couleur);
   extern void id_putchr(u16 chr,u16 couleur,u16 cpt);
   extern void id_write(u8,u16,u16,u16);
   extern void id_read(u8,u16,u16,u16);
   extern void init_pic();
   extern void masquage_it(u8 ICW2_Master,u8 ICW2_Esclave);

   extern "C" sauver_context(u32 adr, u32 activer);
   extern void init_idt();
   extern void module_tr();
   extern void module_tpartage();
   extern void application_tr();




//paging

   extern void init_paging();
   extern void paging_on();
   extern void paging_off();

//memory

   extern u32 memtopage(unsigned long taille_memoire);
   extern u32 vtr(struct tache *, u32 adresse);
   extern u32 svtr(struct tache *, u32 adresse);
   extern int init_memory();
   extern void init_table_alloc();
   extern void *alloc_page();
   extern unsigned long mem_libre();
   extern int liberer_page(u32 adr);

   extern void *alloc_pgt(struct tache *,u16 nbr_page);
   extern void *alloc_pgd(struct tache *);
   extern void *alloc_stack(struct tache *);

   extern void *get_tss_adr(u16 index);
   extern u32  get_tss_taille(u16 index);
   extern "C" void * _alloc_page(u32 debut_alloc_t,u32 fin_alloc_t,u32 kr_reserve_mem);
   extern "C" u32 _mem_libre(u32 debut_alloc_t,u32 fin_alloc_t);

//schedule
   extern struct tache *get_tache(int, struct entete_file *);
   extern int add_file_pret(struct tache *, struct entete_file *);
   extern int rem_file_pret(struct tache *, struct entete_file *);
   extern int add_sem_file(SEMAPHORE,struct file_sem *);
   extern int rem_sem_file(SEMAPHORE,struct file_sem *);
   extern struct tache *processus_pred();
   extern struct tache *round_robin(struct tache *);
   extern void dispatch(struct tache *);
   extern void schedule();    //temps partag
   extern void schedule_tr();
   extern void serveur_tache();
   extern void nop_thread();
   extern struct tache *get_next_tache();
   extern struct tache *get_aperiodique();
   extern void premiere_commutation(struct tache *);
   extern void commuter(struct tache *, struct tache *);
   extern void P(SEMAPHORE);
   extern void V(SEMAPHORE);
   extern void signaler_aperiodique(u16 id);

//timer
   extern void init_timer();

// tches

   extern int creer_tache(THREAD, DATE ri, TIME ci, TIME pi,u16 num_file_sem);
   extern int supprimer_tache(u16 id);
   extern int creer_serveur(DATE ri, TIME ci, TIME pi);

   extern void print_tache(struct tache *);
   extern u32 determiner_Bi(u16);
   extern void set_priorite_plafond();
   extern void init_file_sem();
   extern int get_sem_libre();
   extern int add_semaphore(u16, SEMAPHORE,u32 time);
   extern SEMAPHORE creer_semaphore();
   extern int supprimer_semaphore(SEMAPHORE);
   extern int faisabilite();

//Process

   extern int get_gdt_libre();
   extern int add_gdt_tache();
   extern void rem_gdt_tache();
   extern void * creer_processus(char *nom,u32 taille);
   extern int kill_processus();
   extern u16 get_pid();
   extern void init_process();
   extern void print_process(struct tache *);

//API temps rel utilisateur

   extern void activer_horloge();
   extern void suspendre_tache(u16);
   extern void suspendre_tache_courante();
   extern void reprendre_tache(u16);
   extern u16 tache_courante();
   extern enum etat etat_tache(u16);
   extern DATE get_absolute_time();
   extern DATE time2absolute(u8,u8,u8);
   extern DATE date_sys2absolute(u8,u8,u8);
   extern void suspendre_tache_delai(TIME);

//TIME   voir schedule.cpp

  extern  void __frq_cpu();
  extern double rdtsc();
  extern "C" void _rdtsc(TIME t,u32 frq,u32,u32);
  extern u8 lire_heure(),lire_minute(),lire_seconde();
  extern "C" void _p_time();
  extern "C" u32 _v_time(u32 frq);

// write / read
   extern int _write(u8,u16,u16,u16,u32);
   extern int _read(u8,u16,u16,u16);

//utils

   extern char getchar();
 

#endif  //endif __C32__

#ifdef __C16__
              #ifdef __C32__
                    #undef __C32__
              #endif
   #define adr_init_gdt (unsigned long)0x40000000
   #define adr_init_idt (unsigned long)0x50000000

   #define _fptr far
   #define printk(x,y) _printk(x,y) 
   #define putchr(x,y,z) _putchr(x,y,z)
   extern "C" void  _fptr _printk(const char _fptr *pttr,char couleur);
   extern "C" void  _fptr _putchr(char caractere,char couleur,short int repeter);

   extern void dtct16();
   extern "C" void init_gdt(unsigned long adr);
   extern "C" void mod_prtg(unsigned long adr);
   extern "C" _fptr int _write(unsigned char lect,unsigned short cyl,unsigned short tete,
           unsigned short sect,unsigned short nbr,char  far *p);

   extern "C" _fptr int _read(unsigned char lect,unsigned short cyl,unsigned short tete,
           unsigned short sect,unsigned short nbr,char  far *p);

#endif

#define pushindex asm{push esi;push edi} /*pour empecher le compilateur de les utiliser*/  
#define popindex asm{pop edi;pop esi}
#define maxcol 80
#define pushseg asm{push ds;push es}
#define popseg asm{pop es;pop ds}

extern debug();
extern const char _fptr * hexasc(const char _fptr *, int cpt);
extern const char _fptr * hexascinv(const char _fptr *, int cpt);

extern "C" void print(char _fptr *fmt,...);

extern const char _fptr * strcpy(char _fptr *des,char _fptr *src);
extern char _fptr *strcat(char _fptr *dest,const char _fptr *src);

extern const char  _fptr * decasc (unsigned long i);
extern "C" const char  _fptr * init_cpu(char nbr);
extern "C" unsigned long init_ram(short int i);

extern char _fptr * memncpy(char _fptr *src,char _fptr *dst,int nbr);

extern "C" bascul(unsigned long adresse);
extern void hlt();

extern unsigned char inpb(unsigned short int port);
extern void outpb(unsigned short int port, unsigned char val);

