/*
                 Copyright(c) 2005 Toufik Sarni

This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA*/

#include <kernel.h>

  /* paging_off():
   * dsactiver la pagination, pour que le noyau intervienne dans l'espace
   * utilisateur(modifier sa table des pages ...).
   * (init_page() ci dessous, n'offre que 4MB d'espace).
   * en dsactivant la pagination, on aura accs  4GO, grace  la segmentation
   */
u32 r_eflags,r_cr3;
void paging_off()
 {
  asm{
      push eax
      push ebx
      mov eax,cr3
      mov dword ptr r_cr3,eax
      pushfd                        //  mettre le eflags dans la pile
      mov eax,dword ptr [esp]       //  rcuperer le eflags du sommet de la pile
      mov dword ptr r_eflags,eax    //  sauver cette valeur dans la variable "eflags"
      popfd                         //  dpiler cette valeur
      cli                           //  dsactiver les IT
      mov eax,cr0
      and eax,0x7FFFFFFF            //  mettre le bit PG  0
      mov cr0,eax
      jmp $+2
      mov ebx,offset cont
      jmp ebx
  cont:                             //  reflasher le file des instructions.
      pop ebx
      pop eax
    };
 }
void paging_on()
 {
  asm{
      push eax
      push ebx
      mov eax,r_cr3
      mov cr3,eax
      mov eax,cr0
      or eax,0x80000000
      mov cr0,eax
      jmp $+2
      mov ebx,offset suite
      jmp ebx
  suite:
      mov eax,dword ptr r_eflags
      pushfd
      mov dword ptr [esp],eax
      popfd
      pop ebx
      pop eax

     };
 }



void init_paging()
 {
 print("Activation de la pagination ...\n");

 u32 *page_d=(u32*)ADR_KR_PGD,                                      // rprtoire des pages
     *page_t1=(u32*)ADR_KR_PGT1,                                    // la 1ere table des pages
     *page_t2=(u32*)ADR_KR_PGT2;                                    // la 2eme table des pages

 u32 adresse1=0,adresse2=4*1024*1024;    //adresse2 commence l ou se termine l'adresse1 i.e: au 4eme MO en comptant de 0x100000
 int i;


 for(i=0;i<1024;i++)
 {
    page_t1[i]=(adresse1|3);           // 3: <=> 011b : (0: page systme, 1:READ/WRITE, 1:prsente)
    page_t2[i]=(adresse2|3);
    adresse1+=4096;adresse2+=4096;
 };


 page_d[0]=((u32)page_t1)|3;
 page_d[1]=((u32)page_t2)|3;
 page_t1[0]=0;                        // pour preserver la table des vecteurs d'IT en mode reel (adresse: 0000:0000)
 asm{
     .386p
     mov eax,page_d
     mov cr3,eax
                          //activation de la pagination
     mov eax,cr0
     or eax,0x80000000
     mov cr0,eax
     jmp $+2             //rinitialiser la queue des instructions.
     mov eax,offset next
     jmp eax              //s'assurer de la bonne adresse de la prochaine instruction
   next:
     jmp $+2
     };

    print("Rep-pages: CR3=0x%p   Tables-pages=0x%p et 0x%p\n",page_d,page_t1,page_t2);


  }
